#ifndef HAZEL_KERNEL_H_
#define HAZEL_KERNEL_H_

#include <kernel/multiboot.h>
#include <kernel/log.h>

#define cpu_relax asm volatile ("pause" ::)
#define CHECK_FLAG(x, n) (x & (1<<n))

typedef struct {
   multiboot_memory_map_t *mem_map;
   uint32_t mem_map_len;
   log_method_t log_method;
} kernel_ctx_t;

#endif
